import hljs from "highlight.js";
import marked from "marked";
import ObjectUtils from "qing-utils/src/ObjectUtils";

const renderer = new marked.Renderer();

const defaultOptions = {
  renderer: renderer,
  gfm: true,
  smartLists: true,
  smartypants: true,
  highlight(code) {
    return hljs.highlightAuto(code).value;
  }
}

class MdReader {
  static read(text, options) {
    let assignOptions = defaultOptions
    if (options) {
      assignOptions = ObjectUtils.deepClone(defaultOptions).assign(options)
    }
    marked.setOptions(assignOptions)
    return marked(text)
  }
}

MdReader.renderer = renderer

module.exports = MdReader
